// 644er + DCF77-Modul(PA7) + MQ7-Gas-Sensor(PA3)
#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/io.h>

#define LCD_aktiv
#define MQ7_aktiv

// ***********************************

char lcdbuffer[7];
char f1[3] ="000";
char f5[12] ="000     CND";
#ifdef LCD_aktiv
#include "lcd.h"		//LCD-Display routinen
#define LCD_SET_CGADR	0x40
#define LCD_GC_CHAR0	0		// eigenes LCD-Zeichen Nr. 0f
#endif

#ifdef MQ7_aktiv


uint16_t readADC(uint8_t channel);

#endif

#include "dcf77/dcf77.h"
char daytime[] = "\r  :  :     .  .20  \x0";
//                01234567890123456789012

char * get_time_str(char* timestr)
{
  timestr[2] = (time.hour % 10) + '0';
  timestr[1] = (time.hour / 10) + '0';
  timestr[5] = (time.minute % 10) + '0';
  timestr[4] = (time.minute / 10) + '0';
  timestr[8] = (time.second % 10) + '0';
  timestr[7] = (time.second / 10) + '0';

  timestr[11] = (time.day % 10) + '0';
  timestr[10] = (time.day / 10) + '0';
  timestr[14] = (time.month % 10) + '0';
  timestr[13] = (time.month / 10) + '0';
  timestr[19] = (time.year % 10) + '0';
  timestr[18] = (time.year / 10) + '0';
  if (!synchronize)
    timestr[20] = '*'; // not in sync
  else
    timestr[20] = ' '; // in sync
}
//**************************************************************************
uint16_t readADC(uint8_t channel) {
  uint8_t iii;
  uint16_t result = 0;
  uint16_t res_temp = 0;
  // Den ADC aktivieren und Teilungsfaktor auf 64 stellen
  ADCSRA |= (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);

  // Kanal des Multiplexers waehlen
  // Interne Referenzspannung verwenden (also 2,56 V)
  ADMUX |= channel | (1<<REFS0);
  
  // Den ADC initialisieren und einen sog. Dummyreadout machen
  ADCSRA |= (1<<ADSC);
  while	( (iii<= 100 ) && (ADCSRA & (1<<ADSC)))
	{	iii=0; //iii++;							// Lebensversicherung...
	}
  
  // Jetzt 3x die analoge Spannung and Kanal channel auslesen
  // und dann Durchschnittswert ausrechnen.
  for(iii=0; iii<3; iii++) {
    // Eine Wandlung
    ADCSRA |= (1<<ADSC);
    // Auf Ergebnis warten...
    while(ADCSRA & (1<<ADSC));
    
	res_temp = (ADCW);
	//lcd_gotoxy((2*iii)+3,1);
	//lcd_puts(res_temp);
    result += res_temp;
  }
  
  // ADC wieder deaktivieren
  ADCSRA &= ~(1<<ADEN);
  
  result /= 3;
  
  return result;
}

//*****************************************************************************************************************
int main(void)
{	int i=0; 
  uint8_t flipper;
  uint16_t gas_t = 0;
  int gas_zaehler = 0;
  #ifdef LCD_aktiv
	// LCD Vorbereitung ***************************************
	lcd_init(LCD_DISP_ON);
	lcd_puts("DCF77 - Booting ... ");
	// delay_ms(100);
#endif
  
  timebase_init();
  flipper = 0;

  sei();
	
  while (1)
    {
	#ifdef MQ7_aktiv
	if (gas_zaehler >= 100)
	{	gas_zaehler = 0; 
	    lcd_gotoxy(0,1);
		gas_t = readADC(3);		// PA3
		lcd_gotoxy(0,1);
		//lcd_puts(gas_t);
		
		itoa ( gas_t , lcdbuffer, 10);
		lcd_puts( lcdbuffer );
		lcd_puts("*");
	} else {
		gas_zaehler++;
	}
	#endif
	
      scan_dcf77();     // has to be called at least once every 100ms
	  
#if 1		//  Puls...
      if (DCF77_PIN & 1 << DCF77)
      {  //PORTD &= ~(1 << PD0); }// PD0 shows dcf77-pulse
		DCF77_PORT &= ~(1 << DCF77);}
      else
      {  //PORTD |= 1 << PD0;	
		DCF77_PORT |= 1 << DCF77; }	// !!
#endif
      if (timeflags & 1 << ONE_SECOND)
        {
          timeflags = 0;
          clock();
          //PORTL=synchronize;   wenn Sync, dann "synchronize = 0xFF;"
          if (!synchronize)
            {
            //PORTD &= ~(1 << PD1); // in sync
		DCF77_PORT &= ~( 1 << DCF77 );
              lcd_gotoxy(0,0);
			  switch (flipper++)
                {
              case 0:
                lcd_puts("Wait for Sync -  ");
				//uputs((uint8_t *)"Wait for Sync -    \r");
                break;
              case 1:
			    lcd_puts("Wait for Sync \\  ");
                //uputs((uint8_t *)"Wait for Sync \\    \r");
              break;
              case 2:
				lcd_puts("Wait for Sync |  ");
                //uputs((uint8_t *)"Wait for Sync |    \r");
                break;
              case 3:
				lcd_puts("Wait for Sync /  ");
                //uputs((uint8_t *)"Wait for Sync /    \r");
                break;

                }
              if(flipper == 4)
                flipper=0;
              // no valid Time
            }
          else 
            {
              //PORTL=synchronize;
              get_time_str((char *) daytime);
			  lcd_gotoxy(0,0);
			  lcd_puts(daytime);
			  
            }
        }

    }
  return 0;
}
